using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace GridGroupingRelation
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void startToolStripMenuItem_Click(object sender, EventArgs e)
        {
            DataSet ds = new DataSet();
            DataTable table1 = new DataTable("Objects");
            DataTable table2 = new DataTable("Instances");
            table1.Columns.Add("Id");
            table1.Columns.Add("ObjectName");
            table2.Columns.Add("Id");
            table2.Columns.Add("ObjectId");
            table2.Columns.Add("InstanceName");
            table2.Columns.Add("InstanceTag");
            ds = new DataSet();
            for (int i = 0; i < 10; ++i)
            {
                object[] values = new object[2];
                values[0] = i;
                values[1] = "Object" + i;
                table1.Rows.Add(values);
                for (int j = 0; j < 10; ++j)
                {
                    object[] values2 = new object[4];
                    values2[0] = i * 10 + j;
                    values2[1] = i;
                    values2[2] = "Instance" + values2[0];
                    values2[3] = j / 3 + 2;
                    table2.Rows.Add(values2);
                }
            }
            ds.Tables.Add(table1);
            ds.Tables.Add(table2);

            gridGroupingControl1.DataSource = ds;
            gridGroupingControl1.DataMember = "Objects";

            GridRelationDescriptor rel = new GridRelationDescriptor("relation1");
            rel.RelationKind = Syncfusion.Grouping.RelationKind.RelatedMasterDetails;
            rel.ChildTableName = table2.TableName;
            rel.RelationKeys.Add("Id", "ObjectId");
            gridGroupingControl1.TableDescriptor.Relations.Add(rel);

            this.gridGroupingControl1.TopLevelGroupOptions.ShowFilterBar = true;
            this.gridGroupingControl1.TableDescriptor.Columns["ObjectName"].AllowFilter = true;
            
            this.gridGroupingControl1.NestedTableGroupOptions.ShowFilterBar = true;
            this.gridGroupingControl1.ChildGroupOptions.ShowFilterBar = true;
            GridTableDescriptor tableDescriptor = this.gridGroupingControl1.GetTableDescriptor("Instances");
            tableDescriptor.Columns["InstanceName"].AllowFilter = true;
            tableDescriptor.Columns["InstanceTag"].AllowFilter = true;

        }
    }
}